/*
 * 
 * Vericon version 4.3. Generated Wed Sep 13 11:50:27 2017
 * Auto generated testbench, post edited
 *
 */
// Axi stream splitter testbench
// One slave port, two master ports
//
// Design by G.J. van Loo, FenLogic Ltd, October-2017.
// Mail: verilog@fenlogic.com
//
// This program is free software. It comes without any guarantees or
// warranty to the extent permitted by applicable law. Although the
// author has attempted to find and correct any bugs in this free software
// program, the author is not responsible for any damage or losses of any
// kind caused by the use or misuse of the program. You can redistribute
// the program and or modify it in any form without obligations, but the
// author would appreciated if these credits stays in.
//

module axi_split4_test;

localparam CLK_PERIOD=100;

localparam ADRS_BITS= 32;
localparam DATA_BITS= 32;
localparam LEN_BITS = 4;
localparam ID_BITS  = 6;

 // Depth of the test queues (FIFOs)
localparam AQ_DEPTH = 12; // Max 4K addresses
localparam DQ_DEPTH = 12; // Max 4K data 

// Size of test memory 
localparam L2MEM_DEPTH = 8; // 256 words 

reg   clk;
reg   reset_n;
reg   run;
wire  done;
wire  [2:0] fault;
   
   /****************\
    *              *
    *  SLAVE PORT  *
    *              *
   \****************/

  // write address 
   
wire                   s_awvalid ; 
wire                   s_awready ; 
wire   [ADRS_BITS-1:0] s_awaddr  ; 
wire    [LEN_BITS-1:0] s_awlen   ; 
wire            [ 2:0] s_awsize  ; 
wire     [ID_BITS-1:0] s_awid    ; 
wire            [ 1:0] s_awburst ; 
wire            [ 3:0] s_awcache ; 
wire            [ 1:0] s_awlock  ; 
wire            [ 2:0] s_awprot  ; 
wire            [ 3:0] s_awqos   ; 
                           
   // write data           
wire                   s_wvalid  ; 
wire                   s_wready  ; 
wire   [DATA_BITS-1:0] s_wdata   ; 
wire            [ 3:0] s_wstrb   ; 
wire                   s_wlast   ; 
wire     [ID_BITS-1:0] s_wid     ; 

   // write response    
wire                   s_bvalid  ; 
reg                    s_bready  ; 
wire           [ 1 :0] s_bresp   ; 
wire     [ID_BITS-1:0] s_bid     ; 


   //
   // read interface
   //
   
   // read address 
wire                   s_arvalid; 
wire                   s_arready; 
wire  [ADRS_BITS-1: 0] s_araddr ; 
wire     [ID_BITS-1:0] s_arid   ; 
wire    [LEN_BITS-1:0] s_arlen  ; 
wire           [ 2: 0] s_arsize ; 
wire           [ 1: 0] s_arburst; 
wire           [ 3: 0] s_arcache; 
wire           [ 1: 0] s_arlock ; 
wire           [ 2: 0] s_arprot ; 
wire           [ 3: 0] s_arqos  ; 

   // read data
wire                   s_rvalid ; 
wire                   s_rready ; 
wire   [DATA_BITS-1:0] s_rdata  ; 
wire                   s_rlast  ; 
wire     [ID_BITS-1:0] s_rid    ; 
wire           [ 1 :0] s_rresp  ; 


   /*******************\
    *                 *
    *  MASTER PORT 0  *
    *                 *
   \*******************/

   //
   // write interface
   //
   
wire                   m0_awvalid ; 
wire                   m0_awready ; 
wire   [ADRS_BITS-1:0] m0_awaddr  ; 
wire    [LEN_BITS-1:0] m0_awlen   ; 
wire            [ 2:0] m0_awsize  ; 
wire     [ID_BITS-1:0] m0_awid    ; 
wire            [ 1:0] m0_awburst ; 
wire            [ 3:0] m0_awcache ; 
wire            [ 1:0] m0_awlock  ; 
wire            [ 2:0] m0_awprot  ; 
wire            [ 3:0] m0_awqos   ; 
                           
   // write data           
wire                   m0_wvalid  ; 
wire                   m0_wready  ; 
wire   [DATA_BITS-1:0] m0_wdata   ; 
wire            [ 3:0] m0_wstrb   ; 
wire                   m0_wlast   ; 
wire     [ID_BITS-1:0] m0_wid     ; 

   // write response    
wire                   m0_bvalid  ; 
wire                   m0_bready  ; 
wire           [ 1 :0] m0_bresp   ; 
wire     [ID_BITS-1:0] m0_bid     ; 

   //
   // read interface
   //
   
   // read address 
wire                   m0_arvalid; 
wire                   m0_arready; 
wire  [ADRS_BITS-1: 0] m0_araddr ; 
wire     [ID_BITS-1:0] m0_arid   ; 
wire    [LEN_BITS-1:0] m0_arlen  ; 
wire           [ 2: 0] m0_arsize ; 
wire           [ 1: 0] m0_arburst; 
wire           [ 3: 0] m0_arcache; 
wire           [ 1: 0] m0_arlock ; 
wire           [ 2: 0] m0_arprot ; 
wire           [ 3: 0] m0_arqos  ; 

   // read data
wire                   m0_rvalid ; 
wire                   m0_rready ; 
wire   [DATA_BITS-1:0] m0_rdata  ; 
wire                   m0_rlast  ; 
wire     [ID_BITS-1:0] m0_rid    ; 
wire           [ 1 :0] m0_rresp  ; 


   /*******************\
    *                 *
    *  MASTER PORT 1  *
    *                 *
   \*******************/

   //
   // write interface
   //
   
wire                   m1_awvalid ; 
wire                   m1_awready ; 
wire   [ADRS_BITS-1:0] m1_awaddr  ; 
wire    [LEN_BITS-1:0] m1_awlen   ; 
wire            [ 2:0] m1_awsize  ; 
wire     [ID_BITS-1:0] m1_awid    ; 
wire            [ 1:0] m1_awburst ; 
wire            [ 3:0] m1_awcache ; 
wire            [ 1:0] m1_awlock  ; 
wire            [ 2:0] m1_awprot  ; 
wire            [ 3:0] m1_awqos   ; 
                           
   // write data           
wire                   m1_wvalid  ; 
wire                   m1_wready  ; 
wire   [DATA_BITS-1:0] m1_wdata   ; 
wire            [ 3:0] m1_wstrb   ; 
wire                   m1_wlast   ; 
wire     [ID_BITS-1:0] m1_wid     ; 

   // write response    
wire                   m1_bvalid  ; 
wire                   m1_bready  ; 
wire           [ 1 :0] m1_bresp   ; 
wire     [ID_BITS-1:0] m1_bid     ; 

   //
   // read interface
   //
   
   // read address 
wire                   m1_arvalid; 
wire                   m1_arready; 
wire  [ADRS_BITS-1: 0] m1_araddr ; 
wire     [ID_BITS-1:0] m1_arid   ; 
wire    [LEN_BITS-1:0] m1_arlen  ; 
wire           [ 2: 0] m1_arsize ; 
wire           [ 1: 0] m1_arburst; 
wire           [ 3: 0] m1_arcache; 
wire           [ 1: 0] m1_arlock ; 
wire           [ 2: 0] m1_arprot ; 
wire           [ 3: 0] m1_arqos  ; 

   // read data
wire                   m1_rvalid ; 
wire                   m1_rready ; 
wire   [DATA_BITS-1:0] m1_rdata  ; 
wire                   m1_rlast  ; 
wire     [ID_BITS-1:0] m1_rid    ; 
wire           [ 1 :0] m1_rresp  ; 


   /*******************\
    *                 *
    *  MASTER PORT 2  *
    *                 *
   \*******************/

   //
   // write interface
   //
   
wire                   m2_awvalid ; 
wire                   m2_awready ; 
wire   [ADRS_BITS-1:0] m2_awaddr  ; 
wire    [LEN_BITS-1:0] m2_awlen   ; 
wire            [ 2:0] m2_awsize  ; 
wire     [ID_BITS-1:0] m2_awid    ; 
wire            [ 1:0] m2_awburst ; 
wire            [ 3:0] m2_awcache ; 
wire            [ 1:0] m2_awlock  ; 
wire            [ 2:0] m2_awprot  ; 
wire            [ 3:0] m2_awqos   ; 
                           
   // write data           
wire                   m2_wvalid  ; 
wire                   m2_wready  ; 
wire   [DATA_BITS-1:0] m2_wdata   ; 
wire            [ 3:0] m2_wstrb   ; 
wire                   m2_wlast   ; 
wire     [ID_BITS-1:0] m2_wid     ; 

   // write response    
wire                   m2_bvalid  ; 
wire                   m2_bready  ; 
wire           [ 1 :0] m2_bresp   ; 
wire     [ID_BITS-1:0] m2_bid     ; 

   //
   // read interface
   //
   
   // read address 
wire                   m2_arvalid; 
wire                   m2_arready; 
wire  [ADRS_BITS-1: 0] m2_araddr ; 
wire     [ID_BITS-1:0] m2_arid   ; 
wire    [LEN_BITS-1:0] m2_arlen  ; 
wire           [ 2: 0] m2_arsize ; 
wire           [ 1: 0] m2_arburst; 
wire           [ 3: 0] m2_arcache; 
wire           [ 1: 0] m2_arlock ; 
wire           [ 2: 0] m2_arprot ; 
wire           [ 3: 0] m2_arqos  ; 

   // read data
wire                   m2_rvalid ; 
wire                   m2_rready ; 
wire   [DATA_BITS-1:0] m2_rdata  ; 
wire                   m2_rlast  ; 
wire     [ID_BITS-1:0] m2_rid    ; 
wire           [ 1 :0] m2_rresp  ; 


   /*******************\
    *                 *
    *  MASTER PORT 3  *
    *                 *
   \*******************/

   //
   // write interface
   //
   
wire                   m3_awvalid ; 
wire                   m3_awready ; 
wire   [ADRS_BITS-1:0] m3_awaddr  ; 
wire    [LEN_BITS-1:0] m3_awlen   ; 
wire            [ 2:0] m3_awsize  ; 
wire     [ID_BITS-1:0] m3_awid    ; 
wire            [ 1:0] m3_awburst ; 
wire            [ 3:0] m3_awcache ; 
wire            [ 1:0] m3_awlock  ; 
wire            [ 2:0] m3_awprot  ; 
wire            [ 3:0] m3_awqos   ; 
                           
   // write data           
wire                   m3_wvalid  ; 
wire                   m3_wready  ; 
wire   [DATA_BITS-1:0] m3_wdata   ; 
wire            [ 3:0] m3_wstrb   ; 
wire                   m3_wlast   ; 
wire     [ID_BITS-1:0] m3_wid     ; 

   // write response    
wire                   m3_bvalid  ; 
wire                   m3_bready  ; 
wire           [ 1 :0] m3_bresp   ; 
wire     [ID_BITS-1:0] m3_bid     ; 

   //
   // read interface
   //
   
   // read address 
wire                   m3_arvalid; 
wire                   m3_arready; 
wire  [ADRS_BITS-1: 0] m3_araddr ; 
wire     [ID_BITS-1:0] m3_arid   ; 
wire    [LEN_BITS-1:0] m3_arlen  ; 
wire           [ 2: 0] m3_arsize ; 
wire           [ 1: 0] m3_arburst; 
wire           [ 3: 0] m3_arcache; 
wire           [ 1: 0] m3_arlock ; 
wire           [ 2: 0] m3_arprot ; 
wire           [ 3: 0] m3_arqos  ; 

   // read data
wire                   m3_rvalid ; 
wire                   m3_rready ; 
wire   [DATA_BITS-1:0] m3_rdata  ; 
wire                   m3_rlast  ; 
wire     [ID_BITS-1:0] m3_rid    ; 
wire           [ 1 :0] m3_rresp  ; 



integer  b0,b1,b2,d0,d1,d2;
integer  v0,v1,v2,r0,r1,r2;
integer  adrs,data;
integer  tst,q;

integer v1b,v1i;

   initial
   begin

      clk         = 1'b0;
      reset_n     = 1'b0;
      run         = 1'b0;
   

      
      # (CLK_PERIOD*5);
      reset_n = 1'b1;
      # (CLK_PERIOD*5);
      
      write_data_check_task;      
      
      read_data_check_task;

      // If a test fails it stops at that point
      // Thus if we arrive here we have found no errors.
      // (Which is different from: there are no errors!!)
      $display("************************");
      $display("**                    **");
      $display("**    Test Passed     **");
      $display("**                    **");
      $display("************************");
      $stop;

   end
   
   // 
   // Need delay on bresponse so we can test bresp FF full
   // using random ~66% ready
   always @(posedge clk or negedge reset_n)
   begin
      if (!reset_n)
      begin
         s_bready <= 1'b0;
      end
      else
      begin
         if (($random & 15) > 10)
            s_bready <= 1'b1;
         else
            s_bready <= 1'b0;
      end
   end
   

axi_split4
   #(
      .ADRS_BITS (ADRS_BITS),  // Slave port ID Bits 
      .DATA_BITS (DATA_BITS),  // Slave port ID Bits 
      .ID_BITS   (ID_BITS),    // Slave port ID Bits 
      .LEN_BITS  (LEN_BITS),   // Len bits 
      .MASK      (32'h0000_0C00), // 4x256 words
      .VALUE0    (32'h0000_0000), // Master 0 is lower 256 words
      .VALUE1    (32'h0000_0400), // Master 1 is next 256 words
      .VALUE2    (32'h0000_0800), // Master 2 is next 256 words
      .L2MAXTRANS(3)              // 8 entries
   ) // parameters
axi_split_0 (
      .clk       (clk),
      .reset_n   (reset_n),
   
   /****************\
    *              *
    *  SLAVE PORT  *
    *              *
   \****************/

  // write address 
   
      .s_awvalid(s_awvalid),
      .s_awready(s_awready),
      .s_awaddr (s_awaddr),
      .s_awlen  (s_awlen),
      .s_awsize (s_awsize),
      .s_awid   (s_awid),
      .s_awburst(s_awburst),
      .s_awcache(s_awcache),
      .s_awlock (s_awlock),
      .s_awprot (s_awprot),
      .s_awqos  (s_awqos),
                           
   // write data           
      .s_wvalid (s_wvalid),
      .s_wready (s_wready),
      .s_wdata  (s_wdata),
      .s_wstrb  (s_wstrb),
      .s_wlast  (s_wlast),
      .s_wid    (s_wid),

   // write response    
      .s_bvalid (s_bvalid),
      .s_bready (s_bready),
      .s_bresp  (s_bresp),
      .s_rresp  (s_rresp),
      .s_bid    (s_bid),


   //
   // read interface
   //
   
   // read address 
      .s_arvalid(s_arvalid),
      .s_arready(s_arready),
      .s_araddr (s_araddr),
      .s_arid   (s_arid),
      .s_arlen  (s_arlen),
      .s_arsize (s_arsize),
      .s_arburst(s_arburst),
      .s_arcache(s_arcache),
      .s_arlock (s_arlock),
      .s_arprot (s_arprot),
      .s_arqos  (s_arqos),

   // read data
      .s_rvalid (s_rvalid),
      .s_rready (s_rready),
      .s_rdata  (s_rdata),
      .s_rlast  (s_rlast),
      .s_rid    (s_rid),

///////////////////////////////////////////////////////////   
 
   /*******************\
    *                 *
    *  MASTER PORT 0  *
    *                 *
   \*******************/

   //
   // write interface
   //
   
   // write address 
   
      .m0_awvalid (m0_awvalid),
      .m0_awready (m0_awready),
      .m0_awaddr  (m0_awaddr),
      .m0_awlen   (m0_awlen),
      .m0_awsize  (m0_awsize),
      .m0_awid    (m0_awid),
      .m0_awburst (m0_awburst),
      .m0_awcache (m0_awcache),
      .m0_awlock  (m0_awlock),
      .m0_awprot  (m0_awprot),
      .m0_awqos   (m0_awqos),
                           
   // write data           
      .m0_wvalid  (m0_wvalid),
      .m0_wready  (m0_wready),
      .m0_wdata   (m0_wdata),
      .m0_wstrb   (m0_wstrb),
      .m0_wlast   (m0_wlast),
      .m0_wid     (m0_wid),

   // write response    
      .m0_bvalid  (m0_bvalid),
      .m0_bready  (m0_bready),
      .m0_bresp   (m0_bresp),
      .m0_rresp   (m0_rresp),
      .m0_bid     (m0_bid),


   //
   // read interface
   //
   
   // read address 
      .m0_arvalid (m0_arvalid),
      .m0_arready (m0_arready),
      .m0_araddr  (m0_araddr),
      .m0_arid    (m0_arid),
      .m0_arlen   (m0_arlen),
      .m0_arsize  (m0_arsize),
      .m0_arburst (m0_arburst),
      .m0_arcache (m0_arcache),
      .m0_arlock  (m0_arlock),
      .m0_arprot  (m0_arprot),
      .m0_arqos   (m0_arqos),

   // read data
      .m0_rvalid  (m0_rvalid),
      .m0_rready  (m0_rready),
      .m0_rdata   (m0_rdata),
      .m0_rlast   (m0_rlast),
      .m0_rid     (m0_rid),

 
   /*******************\
    *                 *
    *  MASTER PORT 1  *
    *                 *
   \*******************/
   
   //
   // write interface
   //
   
   // write address 
   
      .m1_awvalid (m1_awvalid),
      .m1_awready (m1_awready),
      .m1_awaddr  (m1_awaddr),
      .m1_awlen   (m1_awlen),
      .m1_awsize  (m1_awsize),
      .m1_awid    (m1_awid),
      .m1_awburst (m1_awburst),
      .m1_awcache (m1_awcache),
      .m1_awlock  (m1_awlock),
      .m1_awprot  (m1_awprot),
      .m1_awqos   (m1_awqos),
                           
   // write data           
      .m1_wvalid  (m1_wvalid),
      .m1_wready  (m1_wready),
      .m1_wdata   (m1_wdata),
      .m1_wstrb   (m1_wstrb),
      .m1_wlast   (m1_wlast),
      .m1_wid     (m1_wid),

   // write response    
      .m1_bvalid  (m1_bvalid),
      .m1_bready  (m1_bready),
      .m1_bresp   (m1_bresp),
      .m1_rresp   (m1_rresp),
      .m1_bid     (m1_bid),


   //
   // read interface
   //
   
   // read address 
      .m1_arvalid (m1_arvalid),
      .m1_arready (m1_arready),
      .m1_araddr  (m1_araddr),
      .m1_arid    (m1_arid),
      .m1_arlen   (m1_arlen),
      .m1_arsize  (m1_arsize),
      .m1_arburst (m1_arburst),
      .m1_arcache (m1_arcache),
      .m1_arlock  (m1_arlock),
      .m1_arprot  (m1_arprot),
      .m1_arqos   (m1_arqos),

   // read data
      .m1_rvalid  (m1_rvalid),
      .m1_rready  (m1_rready),
      .m1_rdata   (m1_rdata),
      .m1_rlast   (m1_rlast),
      .m1_rid     (m1_rid),

 
   /*******************\
    *                 *
    *  MASTER PORT 2  *
    *                 *
   \*******************/
   
   //
   // write interface
   //
   
   // write address 
   
      .m2_awvalid (m2_awvalid),
      .m2_awready (m2_awready),
      .m2_awaddr  (m2_awaddr),
      .m2_awlen   (m2_awlen),
      .m2_awsize  (m2_awsize),
      .m2_awid    (m2_awid),
      .m2_awburst (m2_awburst),
      .m2_awcache (m2_awcache),
      .m2_awlock  (m2_awlock),
      .m2_awprot  (m2_awprot),
      .m2_awqos   (m2_awqos),
                           
   // write data           
      .m2_wvalid  (m2_wvalid),
      .m2_wready  (m2_wready),
      .m2_wdata   (m2_wdata),
      .m2_wstrb   (m2_wstrb),
      .m2_wlast   (m2_wlast),
      .m2_wid     (m2_wid),

   // write response    
      .m2_bvalid  (m2_bvalid),
      .m2_bready  (m2_bready),
      .m2_bresp   (m2_bresp),
      .m2_rresp   (m2_rresp),
      .m2_bid     (m2_bid),


   //
   // read interface
   //
   
   // read address 
      .m2_arvalid (m2_arvalid),
      .m2_arready (m2_arready),
      .m2_araddr  (m2_araddr),
      .m2_arid    (m2_arid),
      .m2_arlen   (m2_arlen),
      .m2_arsize  (m2_arsize),
      .m2_arburst (m2_arburst),
      .m2_arcache (m2_arcache),
      .m2_arlock  (m2_arlock),
      .m2_arprot  (m2_arprot),
      .m2_arqos   (m2_arqos),

   // read data
      .m2_rvalid  (m2_rvalid),
      .m2_rready  (m2_rready),
      .m2_rdata   (m2_rdata),
      .m2_rlast   (m2_rlast),
      .m2_rid     (m2_rid)  ,

 
   /*******************\
    *                 *
    *  MASTER PORT 3  *
    *                 *
   \*******************/
   
   //
   // write interface
   //
   
   // write address 
   
      .m3_awvalid (m3_awvalid),
      .m3_awready (m3_awready),
      .m3_awaddr  (m3_awaddr),
      .m3_awlen   (m3_awlen),
      .m3_awsize  (m3_awsize),
      .m3_awid    (m3_awid),
      .m3_awburst (m3_awburst),
      .m3_awcache (m3_awcache),
      .m3_awlock  (m3_awlock),
      .m3_awprot  (m3_awprot),
      .m3_awqos   (m3_awqos),
                           
   // write data           
      .m3_wvalid  (m3_wvalid),
      .m3_wready  (m3_wready),
      .m3_wdata   (m3_wdata),
      .m3_wstrb   (m3_wstrb),
      .m3_wlast   (m3_wlast),
      .m3_wid     (m3_wid),

   // write response    
      .m3_bvalid  (m3_bvalid),
      .m3_bready  (m3_bready),
      .m3_bresp   (m3_bresp),
      .m3_rresp   (m3_rresp),
      .m3_bid     (m3_bid),


   //
   // read interface
   //
   
   // read address 
      .m3_arvalid (m3_arvalid),
      .m3_arready (m3_arready),
      .m3_araddr  (m3_araddr),
      .m3_arid    (m3_arid),
      .m3_arlen   (m3_arlen),
      .m3_arsize  (m3_arsize),
      .m3_arburst (m3_arburst),
      .m3_arcache (m3_arcache),
      .m3_arlock  (m3_arlock),
      .m3_arprot  (m3_arprot),
      .m3_arqos   (m3_arqos),

   // read data
      .m3_rvalid  (m3_rvalid),
      .m3_rready  (m3_rready),
      .m3_rdata   (m3_rdata),
      .m3_rlast   (m3_rlast),
      .m3_rid     (m3_rid)
                                    
   );

   
   
axi_test_master
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 
   ) // parameters
axi_test_master0 (

      .clk    (clk),
      .reset_n(reset_n),
      .run    (run),
      .done   (done),
      
   // write address
      .awvalid(s_awvalid),
      .awready(s_awready),
      .awaddr (s_awaddr),
      .awlen  (s_awlen),
      .awsize (s_awsize),
      .awid   (s_awid),
      .awburst(s_awburst),
   
      .awcache(s_awcache),
      .awlock (s_awlock),
      .awprot (s_awprot),
      .awqos  (s_awqos),
                           
   // write data           
      .wvalid (s_wvalid),
      .wready (s_wready),
      .wdata  (s_wdata),
      .wstrb  (s_wstrb),
      .wlast  (s_wlast),
      .wid    (s_wid),

   // write response    
   // removed. Need delay and current master does not support that
      .bvalid (),
      .bready (),
      .bresp  (),
      .bid    (),

   //........................
   
   // read address
      .arvalid(s_arvalid),
      .arready(s_arready),
      .araddr (s_araddr),
      .arlen  (s_arlen),
      .arsize (s_arsize),
      .arid   (s_arid),
      .arburst(s_arburst),
   
      .arcache(s_arcache),
      .arlock (s_arlock),
      .arprot (s_arprot),
      .arqos  (s_arqos),
 
   // read data
      .rvalid (s_rvalid),
      .rready (s_rready),
      .rdata  (s_rdata),
      .rresp  (s_rresp),
      .rlast  (s_rlast),
      .rid    (s_rid)
 
       );

//
// "Memory" for master port 0 
//

split_check
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS)    ,
      // Allowed address range 
      .RANGE_LOW   (256*0),
      .RANGE_HIGH  (256*0+256*4-4)
   ) // parameters
split_check_0 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(m0_awvalid),
      .awready(m0_awready),
      .awaddr (m0_awaddr),
      .awlen  (m0_awlen),
      .awsize (m0_awsize),
      .awid   (m0_awid),
      .awburst(m0_awburst),
                           
   // write data           
      .wvalid (m0_wvalid),
      .wready (m0_wready),
      .wdata  (m0_wdata),
      .wstrb  (m0_wstrb),
      .wlast  (m0_wlast),
      .wid    (m0_wid),

   // write response    
      .bvalid (m0_bvalid),
      .bready (m0_bready),
      .bresp  (m0_bresp),
      .rresp  (m0_rresp),
      .bid    (m0_bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(m0_arvalid),
      .arready(m0_arready),
      .araddr (m0_araddr),
      .arid   (m0_arid),
      .arlen  (m0_arlen),
      .arsize (m0_arsize),
      .arburst(m0_arburst),

   // read data
      .rvalid (m0_rvalid),
      .rready (m0_rready),
      .rdata  (m0_rdata),
      .rlast  (m0_rlast),
      .rid    (m0_rid),
      
      .fault  (fault[0])
   );


//
// "Memory" for master port 1 
//

split_check
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS)  ,
      // Allowed address range 
      .RANGE_LOW   (256*4),
      .RANGE_HIGH  (256*4+256*4-4)
   ) // parameters
split_check_1 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(m1_awvalid),
      .awready(m1_awready),
      .awaddr (m1_awaddr),
      .awlen  (m1_awlen),
      .awsize (m1_awsize),
      .awid   (m1_awid),
      .awburst(m1_awburst),
                           
   // write data           
      .wvalid (m1_wvalid),
      .wready (m1_wready),
      .wdata  (m1_wdata),
      .wstrb  (m1_wstrb),
      .wlast  (m1_wlast),
      .wid    (m1_wid),

   // write response    
      .bvalid (m1_bvalid),
      .bready (m1_bready),
      .bresp  (m1_bresp),
      .rresp  (m1_rresp),
      .bid    (m1_bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(m1_arvalid),
      .arready(m1_arready),
      .araddr (m1_araddr),
      .arid   (m1_arid),
      .arlen  (m1_arlen),
      .arsize (m1_arsize),
      .arburst(m1_arburst),

   // read data
      .rvalid (m1_rvalid),
      .rready (m1_rready),
      .rdata  (m1_rdata),
      .rlast  (m1_rlast),
      .rid    (m1_rid),
      
      .fault  (fault[1]) 
   );


//
// "Memory" for master port 2 
//

split_check
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS)  ,
      // Allowed address range 
      .RANGE_LOW   (256*8),
      .RANGE_HIGH  (256*8+256*4-4)
   ) // parameters
split_check_2 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(m2_awvalid),
      .awready(m2_awready),
      .awaddr (m2_awaddr),
      .awlen  (m2_awlen),
      .awsize (m2_awsize),
      .awid   (m2_awid),
      .awburst(m2_awburst),
                           
   // write data           
      .wvalid (m2_wvalid),
      .wready (m2_wready),
      .wdata  (m2_wdata),
      .wstrb  (m2_wstrb),
      .wlast  (m2_wlast),
      .wid    (m2_wid),

   // write response    
      .bvalid (m2_bvalid),
      .bready (m2_bready),
      .bresp  (m2_bresp),
      .rresp  (m2_rresp),
      .bid    (m2_bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(m2_arvalid),
      .arready(m2_arready),
      .araddr (m2_araddr),
      .arid   (m2_arid),
      .arlen  (m2_arlen),
      .arsize (m2_arsize),
      .arburst(m2_arburst),

   // read data
      .rvalid (m2_rvalid),
      .rready (m2_rready),
      .rdata  (m2_rdata),
      .rlast  (m2_rlast),
      .rid    (m2_rid),
      
      .fault  (fault[2]) 
   );


//
// "Memory" for master port 3 
//

split_check
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS)  ,
      // Allowed address range 
      .RANGE_LOW   (256*12),
      .RANGE_HIGH  (256*12+256*4-4)
   ) // parameters
split_check_3 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(m3_awvalid),
      .awready(m3_awready),
      .awaddr (m3_awaddr),
      .awlen  (m3_awlen),
      .awsize (m3_awsize),
      .awid   (m3_awid),
      .awburst(m3_awburst),
                           
   // write data           
      .wvalid (m3_wvalid),
      .wready (m3_wready),
      .wdata  (m3_wdata),
      .wstrb  (m3_wstrb),
      .wlast  (m3_wlast),
      .wid    (m3_wid),

   // write response    
      .bvalid (m3_bvalid),
      .bready (m3_bready),
      .bresp  (m3_bresp),
      .rresp  (m3_rresp),
      .bid    (m3_bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(m3_arvalid),
      .arready(m3_arready),
      .araddr (m3_araddr),
      .arid   (m3_arid),
      .arlen  (m3_arlen),
      .arsize (m3_arsize),
      .arburst(m3_arburst),

   // read data
      .rvalid (m3_rvalid),
      .rready (m3_rready),
      .rdata  (m3_rdata),
      .rlast  (m3_rlast),
      .rid    (m3_rid),
      
      .fault  (fault[2]) 
   );

   // Generate clock. 
   initial
   begin
      clk = 1'b0;
      forever
         #(CLK_PERIOD/2) clk = ~clk;
   end



// ---------------------------
//
// write data test
//
// --------------------------
task write_data_check_task;
begin
   
   q = 0;
   for (tst=0; tst<100000; tst=tst+1)
   begin
   
      // Use random delays 0-3 and burst 1-3
      d0 = $urandom % 4;
      d1 = $urandom % 4;
      b0 = 1+($urandom % 3);

      // Select address in range 0 .. 4x256
      // But stay away from upper boundary of memories
      // as we do not want to burst over it 
      adrs =$urandom % 32'h3FD;
      if (adrs<=32'h0FF && adrs>32'h0FD)
         adrs = adrs & 32'h0FD;
      if (adrs<=32'h1FF && adrs>32'h1FD)
         adrs = adrs & 32'h1FD;
      if (adrs<=32'h2FF && adrs>32'h2FD)
         adrs = adrs & 32'h2FD;
      
      // Address is word address (*4)
      // So adjust data as well 
      data = adrs<<2;
      
      // Queue up a synced write (address & data)
      axi_test_master0.q_wsync(
                          adrs<<2, // address;
                               b0, // length;
                               32, // size;
                                0, // id;
                                1, // bursttype;
                                0, // delay_random;
                               d0, // delay;
                             data, // data;
                             4'hF, // strobes;
                        b0==1?1:0, // last;
                                0, // delay_random;
                               d1  // delay;
                               );
                        // Next value 
                        data = data + 4;
      // If we have a burst (bx>1) queue more data                         
                        for (r0=1; r0<b0;r0=r0+1)
                        begin
      axi_test_master0.q_wdata(data, // data
                               4'hF, // strobes
                       r0==b0-1?1:0, // last 
                                  0, // ID
                                  0, // delay_random
                                  0  // delay
                               );
                           data = (data + 4);
                        end
      
      // prevent master queues from overflow 
      // With burst>=address check data size only 
      q = q + b0;
      if (q>((1<<DQ_DEPTH)-32))
      begin
         # (CLK_PERIOD*5);
         run = 1'b1;
         # (CLK_PERIOD*5);
         wait (done);
         # (CLK_PERIOD*5);
         run = 1'b0;
         q = 0;
      end

   end // for tst

   # (CLK_PERIOD*5);
   run = 1'b1;
   # (CLK_PERIOD*5);
   wait (done);
   # (CLK_PERIOD*5);
   run = 1'b0;
   
   if ( |fault )
   begin
      $display("%m @%0t: errors in test",$time);
      #1 $stop;
   end
   else
      $display("%m @%0t: write_data_check_task passed",$time);
   
end
endtask // write_data_check_task



// ---------------------------
//
// read data test
//
// --------------------------
task read_data_check_task;
begin
   
   q = 0;
   for (tst=0; tst<100000; tst=tst+1)
   begin
   
      // Use random delays 0-3 and burst 1-3
      d0 = $urandom % 4;
      d1 = $urandom % 4;
      b0 = 1+($urandom % 3);

      // Select address in range 0 .. 4x256
      // But stay away from upper boundary of memories
      // as we do not want to burst over it 
      adrs =$urandom % 32'h3FD;
      if (adrs<=32'h0FF && adrs>32'h0FD)
         adrs = adrs & 32'h0FD;
      if (adrs<=32'h1FF && adrs>32'h1FD)
         adrs = adrs & 32'h1FD;
      if (adrs<=32'h2FF && adrs>32'h2FD)
         adrs = adrs & 32'h2FD;
      
      // Address is word address (*4)
      // So adjust data as well 
      data = adrs<<2;
      
      // Queue up a synced read (address & data)
                  axi_test_master0.q_ardata(
                                      adrs<<2, // address;
                                           b0, // length;
                                           32, // size;
                                            0, // id;
                                            1, // bursttype;
                                            0, // delay_random;
                                           d0, // delay;
                                         data, // data;
                                    b0==1?1:0, // last;
                                            0, // delay_random;
                                           d1, // delay;
                                            0  // delay mode 
                                           );
                                    // Next value 
                                    data = data + 4;
                  // If we have a burst (b0>1) queue more expected data                         
                                    for (r0=1; r0<b0;r0=r0+1)
                                    begin
                  // args= data,last,id,delay_random,delay,delay_mode
                  axi_test_master0.q_rdata(data, // data 
                                   r0==b0-1?1:0, // last
                                              0, // id
                                              0, // delay_random
                                              0, // delay
                                              0  // delay_mode
                                        );
                                       data = data + 4;
                                    end
      
      // prevent master queues from overflow 
      // With burst>=address check data size only 
      q = q + b0;
      if (q>((1<<DQ_DEPTH)-32))
      begin
         # (CLK_PERIOD*5);
         run = 1'b1;
         # (CLK_PERIOD*5);
         wait (done);
         # (CLK_PERIOD*5);
         run = 1'b0;
         q = 0;
      end

   end // for tst

   # (CLK_PERIOD*5);
   run = 1'b1;
   # (CLK_PERIOD*5);
   wait (done);
   # (CLK_PERIOD*5);
   run = 1'b0;
   
   if ( |fault )
   begin
      $display("%m @%0t: errors in test",$time);
      #1 $stop;
   end
   else
      $display("%m @%0t: read_data_check_task passed",$time);
   
end
endtask // read_data_check_task


    
endmodule
